# This confidential and proprietary software may be used only as
# authorised by a licensing agreement from ARM Limited
# (C) COPYRIGHT 2017-2018 ARM Limited
# ALL RIGHTS RESERVED
# The entire notice above must be reproduced on all authorised
# copies and copies may only be made to the extent permitted
# by a licensing agreement from ARM Limited.

# API levels are ten times bigger than official ones, because JBMR1 and JBMR1.1
# share the same API level (17) but they are not compatible from our point of view so
# we need to distinguish between them.
_api_levels = {
    'o'     : 260,
    'omr1'  : 270,
    'p'     : 280,
    'future': 290,  # Future is experimental support for before official releases
}

_api_aliases = {
    'oreo'        : 'o',
    'oreomr1'     : 'omr1',
    'pie'         : 'p',
}

# Android API levels where LTO can be enabled
_lto_supported_api_levels = [ ]

# Deprecated Android API levels
_deprecated_api_levels = [ ]

def is_deprecated(version):
    return api_level(version) in _deprecated_api_levels

def lto_supported(version):
    return api_level(version) in _lto_supported_api_levels

# Return the API level for known versions of Android
def api_level(version):
    if _api_aliases.get(version):
        version = _api_aliases[version]
    return _api_levels[version]

# Return a list of known Android versions
def versions():
    versions_list = _api_levels.keys()
    versions_list.extend(_api_aliases.keys())
    versions_list.sort()
    return versions_list
